<?

$thisprog="setforum.php";

require("adminglobal.php");

$forumfile="datafile/forumdata.php";

print "<tr><td bgcolor=#80809b colspan=3><font color=#FFFFFF>
    <b>欢迎来到讨论区管理程式 / 论坛版块管理</b>
    </td></tr>
";

if (file_exists($forumfile)) {
	$forumdata=file($forumfile);
	$count=count($forumdata);
}

if (empty($action)) {
	$forumselect="";
	$forumonly="";
	for($i=0; $i<$count; $i++) {
	  $detail=explode("|",$forumdata[$i]);
	  $forumselect.="<option value=\"$detail[3]\">$detail[1]</option>";
	  if ($detail[0]!="category") $forumonly.="<option value=\"$detail[3]\">$detail[1]</option>";
	}
	$forumselect.="</select>"; $forumonly.="</select>";
	print <<<EOT
    <tr><td bgcolor=#FFFFFF colspan=3>
    <b>1.新建一个类别/版块：</b>
    <form action="$thisprog" method=POST><input type=hidden name="action" value="newitem">
    $tab_top
    没什么要解释的吧<br>
    新建项目类别：<input type=radio checked name="type" value="category">类别 <input type=radio name="type" value="forum">版块 <input type=radio name="type" value="selection">精华区<br>
    <input type=text name="name" size=20>名称&nbsp;&nbsp;<input type=text name="des" size=26>描述(类别无须)
    <input type=submit value="提 交">
    $tab_bottom</form>
    <b>2.改变项目顺序：</b>
    <form action="$thisprog" method=POST><input type=hidden name="action" value="modifyorder">
    $tab_top
    如果你想改变一个版块的位置或者比如是新建一个版块应该属于前面的类别。<br>
    将项目 <select name="item1">$forumselect 移动到 <select name="item2">$forumselect 之后 <input type=submit value="提 交">
    $tab_bottom</form>
    <b>3.版块管理员设置</b><form action="$thisprog" method=POST><input type=hidden name="action" value="moderator">
    $tab_top
    在这里你可以增加和删除版块管理员<br>
    具体动向：<input type=radio checked name="job" value="add">增加  <input type=radio checked name="job" value="del">删除&nbsp;&nbsp;
    斑竹：<input type=text name="userid" size=8>&nbsp; 执行版块：<select name="forumid">$forumonly <input type=submit value="提 交">
    $tab_bottom</form>
    <b>4.删除/修改项目</b><form action="$thisprog" method=POST><input type=hidden name="action" value="moditem">
    $tab_top
    在这里你可以删除版块或者分类<br>
    对象：<select name="target">$forumselect 动作：<input type=radio checked name="job" value="modify">修改(不填则不做修改) <input type=radio name="job" value="delete">删除<br>
    <input type=text name="name" size=20>新名称&nbsp;&nbsp;<input type=text name="des" size=26>新描述 <input type=submit value="提 交">
    $tab_bottom</form>
    </td></tr></td></tr></table></body></html>
EOT;
exit;
}elseif ($action=="newitem") {
//-------新建项目-----------
	$newstring="";
	print "<tr><td bgcolor=#EEEEEE valign=middle align=center colspan=2><b>新建项目</b></td></tr>
	<tr><td bgcolor=FFFFFF colspan=2>";

	if ($type=="category") {
		//-----增加分类------
		$name=str_replace("|","",$name);
        	$t=time();
        	$newstring="category|$name||$t|\n";
        } elseif ($type=="selection" || $type=="forum") {
		//-----增加版块------
		$des=str_replace("|","",$des); $name=str_replace("|","",$name); $name=stripslashes($name); $des=stripslashes($des);
		$max=0;
		for ($i=0; $i<$count; $i++) {
			$temp=explode("|",$forumdata[$i]);
			if ($temp[0]!="category") $max=max($max,$temp[3]);
		}
		$id=$max+1;
		while(file_exists("forum$id")) $id++;
		if (mkdir("forum$id",0777)) {
			echo "<b>成功建立目录forum$id</b>";
		} else {
			echo "<b>建立目录forum$id失败，请手工建立并设置权限为777</b>";
		}
        	$newstring="$type|$name|$des|$id|\n";
        }
	$fp=fopen($forumfile,"a");
	if (fwrite($fp,$newstring)) echo "<br><br>成功更新论坛列表资料<b></b><br>";
		else echo "<br><br>论坛列表更新失败，请检查datafile目录及forumdata.php之属性<b></b><br>";
	fclose($fp);
}elseif ($action=="modifyorder") {
//-------改变顺序-----------
	print "<tr><td bgcolor=#EEEEEE valign=middle align=center colspan=2><b>修改顺序</b></td></tr>
	<tr><td bgcolor=FFFFFF colspan=2>";

	$new="";
	for ($i=0; $i<$count; $i++) {
	  $detail=explode("|",$forumdata[$i]);
	  if ($detail[3]!=$item1) $new.=$forumdata[$i];
	  if ($detail[3]==$item2) {
	    for ($j=0; $j<$count; $j++) {
	       $detail2=explode("|",$forumdata[$j]);
	       if ($detail2[3]==$item1) $new.=$forumdata[$j];
	    }
	  }
	}
	writetofile($forumfile,$new);
}elseif ($action=="moderator") {
//-------斑竹设置-----------
	print "<tr><td bgcolor=#EEEEEE valign=middle align=center colspan=2><b>斑竹设置</b></td></tr>
	<tr><td bgcolor=FFFFFF colspan=2>";

	$adminfile="datafile/admin.php";
	if ($job=="add") {
		$fp=fopen($adminfile,"a");
		flock($fp,LOCK_EX);
		fputs($fp,"$forumid|$userid|\n");
		fclose($fp);
	}else {
		$adminlist=file($adminfile);
		$count=count($adminlist);
		$fp=fopen($adminfile,"w");
		flock($fp,LOCK_EX);
		for ($i=0; $i<$count; $i++){
			$info=explode("|",$adminlist[$i]);
			if ($info[0]!=$forumid || $info[1]!=$userid) fputs($fp,$adminlist[$i]);
		}
		fclose($fp);
	}
}elseif ($action=="moditem") {
//-------删除/修改项目-----------
	print "<tr><td bgcolor=#EEEEEE valign=middle align=center colspan=2><b>修改/删除项目</b></td></tr>
	<tr><td bgcolor=FFFFFF colspan=2>";

for ($i=0; $i<$count; $i++) {
  $detail=explode("|",$forumdata[$i]);
  if ($detail[3]==$target) {
    if ($job=="modify") {
      if (!empty($name)) $detail[1]=$name;
      if (!empty($des) && $detail[0]!="category") $detail[2]=$des;
      $new[]=implode("|",$detail);
    }
  }
  else $new[]=$forumdata[$i];
}
$new=implode("",$new);
writetofile($forumfile,$new);
}
print "<br><b>&nbsp;操作完成</b><br><br>&nbsp;&gt;&gt; <a href=$thisprog>返回执行其他动作</a></td></tr></table></body></html>";
exit;